'SHA512Checksum

'Initialisierungskonstanten
#Define H0 &H6a09e667f3bcc908ULL
#Define H1 &Hbb67ae8584caa73bULL
#Define H2 &H3c6ef372fe94f82bULL
#Define H3 &Ha54ff53a5f1d36f1ULL
#Define H4 &H510e527fade682d1ULL
#Define H5 &H9b05688c2b3e6c1fULL
#Define H6 &H1f83d9abfb41bd6bULL
#Define H7 &H5be0cd19137e2179ULL

'*******************************************************

#Define Ch(x,y,z) ((x And y) Xor ((Not x) And z))
#Define Maj(x,y,z) ((x And y) Xor (x And z) Xor (y And z))

#Define Sum0(x) (ROTR(28,x) Xor ROTR(34,x) Xor ROTR(39,x))
#Define Sum1(x) (ROTR(14,x) Xor ROTR(18,x) Xor ROTR(41,x))

#Define Sig0(x) (ROTR( 1,x) Xor ROTR( 8,x) Xor SHRR( 7,x))
#Define Sig1(x) (ROTR(19,x) Xor ROTR(61,x) Xor SHRR( 6,x))

'*******************************************************

Function SHRR(n As ULongInt,x As ULongInt) As ULongInt
	Return (x Shr n)
End Function

Function ROTR(y As ULongInt, x As ULongInt) As ULongInt
	Return ((x Shr y) Or (x Shl (64 - y)))
End Function

'*******************************************************

Type SHA512Checksum
	Public:
	Declare Constructor()
	Declare Destructor()
	
	Declare Sub Transform(inpt As UByte Ptr)
	Declare Sub Update(dat As UByte Ptr, length As UInteger)
	Declare Function Final() As String
	
	Private:
	As ULongInt state(8)
	As UInteger count(4)
	As UByte buf(128)
End Type
